<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="培训状态" prop="planStatus">
        <el-select v-model="queryParams.planStatus" placeholder="请选择培训状态" clearable size="small">
          <el-option
            v-for="dict in planStatusOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="开始时间" prop="startdate">
        <el-date-picker clearable size="small" style="width: 200px"
                        v-model="queryParams.startdate"
                        type="date"
                        value-format="yyyy-MM-dd"
                        placeholder="选择开始时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="结束时间" prop="enddate">
        <el-date-picker clearable size="small" style="width: 200px"
                        v-model="queryParams.enddate"
                        type="date"
                        value-format="yyyy-MM-dd"
                        placeholder="选择结束时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['tsnew:tsnew:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="tnNewList" @selection-change="handleSelectionChange" :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <!--      <el-table-column label="培训员工编号" align="center" prop="staffId" :show-overflow-tooltip="true"/>-->
      <el-table-column label="新员工" align="center" prop="staffName" width="100" />
      <el-table-column label="培训状态" align="center" prop="planStatus" width="120" :formatter="planStatusFormat" >
        <template slot-scope="scope">
          <el-tag v-if="scope.row.planStatus == 2" size="small" type="warning">待考试</el-tag>
          <el-tag v-if="scope.row.planStatus == 3" size="small" type="success">已完成</el-tag>
          <el-tag v-if="scope.row.planStatus == 1" size="small" type="danger">已中止</el-tag>
          <el-tag v-else-if="scope.row.planStatus == 0" size="small" type="info">未完成</el-tag>
          <el-tag v-else-if="scope.row.planStatus == 4" size="small" type="danger">已中止待审批</el-tag>
          <el-tag v-else-if="scope.row.planStatus == 5" size="small" type="success">已完成待审批</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="进度" align="center" width="160">
        <template slot-scope="scope">
          <el-progress :percentage="scope.row.planFinish"></el-progress>
        </template>
      </el-table-column>
      <el-table-column label="开始时间" align="center" prop="startdate" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.startdate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="结束时间" align="center" prop="enddate" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.enddate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <!--      <el-table-column label="导师员工编号" align="center" prop="mentorStaffId" :show-overflow-tooltip="true"/>-->
      <el-table-column label="导师" align="center" prop="mentorStaffName" width="100" />
      <el-table-column label="岗位" align="center" prop="planType" width="100">
        <template slot-scope="scope">
          <span v-if="scope.row.planType == 1" size="small" type="success">裂解</span>
          <span v-else-if="scope.row.planType == 2" size="small" type="success">压缩</span>
          <span v-else-if="scope.row.planType == 3" size="small" type="success">分离</span>
          <span v-else-if="scope.row.planType == 4" size="small" type="success">芳烃</span>
        </template>
      </el-table-column>
      <el-table-column label="三级教育记录卡" align="center" prop="three" width="80">
        <template slot-scope="scope">
          <el-button  icon="el-icon-folder" style="color:#6e96fa;" @click="handleDoc(scope.row , 'tsNew-three')" circle></el-button>
        </template>
      </el-table-column>
      <el-table-column label="上岗能力评测表" align="center" prop="firstplan-score" width="80">
        <template slot-scope="scope">
          <el-button  icon="el-icon-folder" style="color:#6e96fa;" @click="handleDoc(scope.row , 'tsNew-firstplan-score')" circle></el-button>
        </template>
      </el-table-column>
      <el-table-column label="导师提名表" align="center" prop="agreement" width="80">
        <template slot-scope="scope">
          <el-button  icon="el-icon-folder" style="color:#6e96fa;" @click="handleDoc(scope.row , 'tsNew-teacher-order')" circle></el-button>
        </template>
      </el-table-column>
      <el-table-column label="带徒协议" align="center" prop="agreement" width="80">
        <template slot-scope="scope">
          <el-button  icon="el-icon-folder" style="color:#6e96fa;" @click="handleDownloadWord(scope.row, 'mentorAgreement')" circle></el-button>
        </template>
      </el-table-column>
      <el-table-column label="带徒目标" align="center" prop="target" width="80">
        <template slot-scope="scope">
          <el-button  icon="el-icon-folder" style="color:#6e96fa;" @click="handleDownloadWord(scope.row, 'targetPlan')" circle></el-button>
        </template>
      </el-table-column>
      <el-table-column label="培训考评" align="center" prop="tnNew-score" width="80">
        <template slot-scope="scope">
          <el-button  icon="el-icon-folder" style="color:#6e96fa;" @click="handleDownloadWord(scope.row, 'appraisalForm')" circle></el-button>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remarks" :show-overflow-tooltip="true" width="100"/>
      <el-table-column label="操作" align="center" fixed="right"  class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-view"
            @click="planList(scope.row)"
          >培训计划</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 用户导入对话框 -->
    <el-dialog  :close-on-click-modal="false" :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url + '?updateSupport=' + upload.updateSupport"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          将文件拖到此处，或
          <em>点击上传</em>
        </div>
        <div class="el-upload__tip" slot="tip">
          <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据
          <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
        </div>
        <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 报告附件对话框 -->
    <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="doc.title" :visible.sync="doc.open" width="1000px" append-to-body >
      <el-upload v-hasPermi="['training:trainingrecords:file']"
                 ref="doc"
                 :limit="50"
                 :headers="doc.headers"
                 :action="doc.url + '?pType=' + doc.pType + '&pId=' + doc.pId"
                 :disabled="doc.isUploading"
                 :on-progress="handleFileDocProgress"
                 :on-success="handleFileDocSuccess"
                 :auto-upload="true"
                 drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          {{ $t('将文件拖到此处，或') }}
          <em>{{ $t('点击上传') }}</em>
        </div>
      </el-upload>
      <el-table :data="doc.commonfileList" border>
        <el-table-column :label="$t('文件名')" align="center" prop="fileName" :show-overflow-tooltip="true">
          <template slot-scope="scope">
            <a  class="link-type"  @click="handleDownload(scope.row)">
              <span>{{ scope.row.fileName }}</span>
            </a>
          </template>
        </el-table-column>
        <el-table-column :label="$t('大小(Kb)')" align="center" prop="fileSize" :show-overflow-tooltip="true" width="80" />
        <el-table-column :label="$t('上传人')" align="center" prop="creator" :show-overflow-tooltip="true" width="120"/>
        <el-table-column :label="$t('操作')" align="center" width="220" class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              v-if="scope.row.fileName.endsWith('pdf')"
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleSee(scope.row)"
            >{{ $t('预览') }}</el-button>
            <el-button v-hasPermi="['training:trainingrecords:file']"  type="text" size="small" v-if="scope.row.isEdit" @click="save(scope.row)">保存</el-button>
            <el-button type="text" size="small" v-if="scope.row.isEdit" @click="cancelFile(scope.row, scope.$index)">取消</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-download"
              @click="handleDownload(scope.row)"
            >{{ $t('下载') }}</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDeleteDoc(scope.row)"
              v-hasPermi="['training:trainingrecords:file']"
            >{{ $t('删除') }}</el-button>
          </template>
        </el-table-column>
      </el-table>
      <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="pdf.title" :visible.sync="pdf.open" width="1300px" append-to-body>
        <div style="margin-top: -60px;float: right;margin-right: 40px;">
          <el-button size="mini" type="text" @click="openPdf">{{$t('新页面打开PDF')}}</el-button></div>
        <div style="margin-top: -30px">
          <iframe :src="pdf.pdfUrl" frameborder="0" width="100%" height="700px"></iframe>
        </div>
      </el-dialog>

      <div slot="footer" class="dialog-footer">
        <el-button @click="doc.open = false">{{ $t('返 回') }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  addTsnew,
  delTsnew,
  exportTsnew,
  genAppraisalFormWord,
  getTsnew,
  importTemplate,
  listTsnew,
  updateTsnew
} from "@/api/training/bccnew/tsnew";
import {treeselect} from "@/api/system/dept";
import {getToken} from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {listStaff} from "@/api/training/newstaff/tnNew";
import {allFileList, delCommonfile} from "@/api/common/commonfile";
import { Loading } from 'element-ui';
import {date} from "mockjs/src/mock/random/date";
import {listUserNoPage} from "@/api/system/user";
import {listStaffmgrByDeptAndTeam} from "@/api/plant/staffmgr";

export default {
  name: "Tsnew",
  components: { Treeselect },
  data() {
    return {
      pickerOptions: {
        shortcuts: [{
          text: '最近一个月',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            end.setTime(start.getTime() + 3600 * 1000 * 24 * 30);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: '最近三个月',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            end.setTime(start.getTime() + 3600 * 1000 * 24 * 90);
            picker.$emit('pick', [start, end]);
          }
        },{
          text: '最近一年',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            end.setTime(start.getTime() + 3600 * 1000 * 24 * 365);
            picker.$emit('pick', [start, end]);
          }
        }, ]
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 新员工培训表格数据
      tnNewList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight:300,
      // 培训状态字典
      planStatusOptions: [],
      // 培训类型 1-新员工 2-转岗字典
      planTypeOptions: [],
      userOption:[],
      // 是否显示弹出层
      open: false,
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/newstaff/tsNew/importData"
      },
      // 报告附件参数
      doc: {
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "附件",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 报告附件上传位置编号
        ids: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/common/commonfile/uploadFile",
        commonfileList: null,
        queryParams: {
          pId: null,
          pType: 'traning'
        },
        pType: 'traning',
        pId: null,
        form: {}
      },
      pdf : {
        title: '',
        pdfUrl: '',
        numPages: null,
        open: false,
        pageNum: 1,
        pageTotalNum: 1,
        loadedRatio: 0,
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        name: null,
        isStudent: '1',
        planStatus: null,
        startdate: null,
        enddate: null,
        planType: null,
      },
      isEdit:false,
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        mentorStaffId: [
          { required: true, message: this.$t('导师') + this.$t('不能为空'), trigger: "change" }
        ],
        staffId: [
          { required: true, message: this.$t('培训员工') + this.$t('不能为空'), trigger: "change" }
        ],
        trainingDate: [
          { required: true, message: this.$t('培训时间') + this.$t('不能为空'), trigger: "blur" }
        ],
        planType: [
          { required: true, message: this.$t('岗位') + this.$t('不能为空'), trigger: "change" }
        ],
      }
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight -250
    })
    this.getList();
    this.getTreeselect();
    this.getDicts("training_bccnew_status").then(response => {
      this.planStatusOptions = response.data;
    });
    this.getDicts("training_newstaff_type").then(response => {
      this.planTypeOptions = response.data;
    });
  },
  methods: {
    // 文件下载处理
    handleDownloadWord(row, type) {
      let name;
      let url;
      console.log(row)
      if (type == 'mentorAgreement') {
        name = row.mentorAgreementWordPath;
        url = row.mentorAgreementWordPath;
        const a = document.createElement('a')
        a.setAttribute('download', name)
        a.setAttribute('target', '_blank')
        a.setAttribute('href', process.env.VUE_APP_BASE_API + url)
        a.click()
      } else if (type == 'targetPlan') {
        name = row.targetPlanWordPath;
        url = row.targetPlanWordPath;
        const a = document.createElement('a')
        a.setAttribute('download', name)
        a.setAttribute('target', '_blank')
        a.setAttribute('href', process.env.VUE_APP_BASE_API + url)
        a.click()
      } else if (type == 'appraisalForm') {
        genAppraisalFormWord(row.newId).then(res=>{
          name = res.msg;
          url = res.msg;
          console.log(url)
          const a = document.createElement('a')
          a.setAttribute('download', name)
          a.setAttribute('target', '_blank')
          a.setAttribute('href', process.env.VUE_APP_BASE_API + url)
          a.click()
        })
      }
    },
    /** 查询新员工培训列表 */
    getList() {
      this.loading = true;
      listTsnew(this.queryParams).then(response => {
        this.tnNewList = response.rows;
        for (const item of this.tnNewList) {
          item.planFinish=parseInt(item.planFinish)
        }
        this.total = response.total;
        this.loading = false;
        console.log(this.tnNewList)
      });

    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    // 培训状态字典翻译
    planStatusFormat(row, column) {
      return this.selectDictLabel(this.planStatusOptions, row.planStatus);
    },
    // 培训类型 1-新员工 2-转岗字典翻译
    planTypeFormat(row, column) {
      return this.selectDictLabel(this.planTypeOptions, row.planType);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        trainingDate: null,
        newId: null,
        staffId: null,
        name: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        planStatus: 0,
        planYear: null,
        startdate: null,
        enddate: null,
        mentorStaffId: null,
        planType: null,
        remarks: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.newId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    planList(row){
      const newId = row.newId
      this.$router.push("/training/bccnew/trainingPlan_s/" + newId);
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.isEdit=false;
      this.reset();
      this.open = true;
      this.title = "添加新员工培训";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.isEdit=true;
      this.reset();
      const newId = row.newId || this.ids
      getTsnew(newId).then(response => {
        response.data.trainingDate=[];
        response.data.trainingDate[0]=new Date( response.data.startdate);
        response.data.trainingDate[1]=new Date( response.data.enddate);
        this.form = response.data;
        this.open = true;
        this.title = "修改新员工培训";
        console.log(this.form)
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          let options={
            text:'正在添加新员工导师带徒培训'
          }
          let loadingInstance = Loading.service(options);
          this.form.startdate=this.form.trainingDate[0];
          this.form.enddate=this.form.trainingDate[1];
          if (this.form.newId != null) {
            updateTsnew(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
              this.$nextTick(() => { // 以服务的方式调用的 Loading 需要异步关闭
                loadingInstance.close();
              });
            });
          } else {
            addTsnew(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
              this.$nextTick(() => { // 以服务的方式调用的 Loading 需要异步关闭
                loadingInstance.close();
              });
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const newIds = row.newId || this.ids;
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        return delTsnew(newIds);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有新员工培训数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        return exportTsnew(queryParams);
      }).then(response => {
        this.download(response.msg);
      })
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "用户导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      importTemplate().then(response => {
        this.download(response.msg);
      });
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    /** 报告附件按钮操作 */
    handleDoc(row , fileType) {
      this.doc.pType = fileType
      this.doc.queryParams.pType = fileType
      this.doc.id = row.id;
      this.doc.title = this.$t('附件') ;
      this.doc.open = true;
      this.doc.queryParams.pId = row.newId
      this.doc.pId = row.newId
      this.getFileList()
      this.$nextTick(() => {
        this.$refs.doc.clearFiles()
      })
    },
    getFileList (){
      allFileList(this.doc.queryParams).then(response => {
        response.forEach(element => {
          element["isEdit"] = false
        });
        response.forEach(element => {
          element["isAdd"] = false
        });
        this.doc.commonfileList = response;
      });
    },
    //附件上传中处理
    handleFileDocProgress(event, file, fileList) {
      this.doc.file = file;
      this.doc.isUploading = true;
    },
    //附件上传成功处理
    handleFileDocSuccess(response, file, fileList) {
      this.doc.isUploading = false;
      this.$alert(response.msg, this.$t('导入结果'), { dangerouslyUseHTMLString: true });
      this.getFileList()
    },
    // 文件下载处理
    handleDownload(row) {
      var name = row.fileName;
      var url = row.fileUrl;
      var suffix = url.substring(url.lastIndexOf("."), url.length);
      const a = document.createElement('a')
      a.setAttribute('download', name)
      a.setAttribute('target', '_blank')
      a.setAttribute('href', process.env.VUE_APP_BASE_API + url)
      a.click()
    },
    openPdf(){
      window.open(this.pdf.pdfUrl);//path是文件的全路径地址
    },
    handleSee (row){
      // window.open(process.env.VUE_APP_BASE_API +'/pdf/web/viewer.html?file=' + process.env.VUE_APP_BASE_API + row.fileUrl);//path是文件的全路径地址
      this.pdf.open =true
      this.pdf.title = row.fileName
      this.pdf.pdfUrl = process.env.VUE_APP_BASE_API +'/pdf/web/viewer.html?file=' + process.env.VUE_APP_BASE_API + row.fileUrl
    },
    /** 删除按钮操作 */
    handleDeleteDoc(row) {
      const ids = row.id || this.ids;
      this.$confirm(this.$t('是否确认删除?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: "warning"
      }).then(function() {
        return delCommonfile(ids);
      }).then(() => {
        this.getFileList()
        this.msgSuccess(this.$t('删除成功'));
      })
    },
  }
};
</script>
